# Generated by Django 4.2 on 2024-01-27 01:00

from django.conf import settings
from django.db import migrations, models


class Migration(migrations.Migration):

    initial = True

    dependencies = [
        ('auth', '0012_alter_user_first_name_max_length'),
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
    ]

    operations = [
        migrations.CreateModel(
            name='Subdomain',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False)),
                ('name', models.CharField(blank=True, default='Test Subdomain', max_length=64, null=True, unique=True)),
                ('subdomain', models.CharField(max_length=255, unique=True)),
                ('base_domain', models.CharField(default='*', help_text='Leave * for all domains', max_length=255, verbose_name='Base Domain')),
                ('created_at', models.DateTimeField(auto_now_add=True)),
                ('urlconf', models.CharField(default='Root.urls', max_length=255)),
                ('last_update', models.DateTimeField(blank=True, null=True)),
                ('allow_none', models.BooleanField(default=True, help_text='Allow None Role Access', verbose_name='Allow None')),
                ('is_active', models.BooleanField(default=True, help_text='Is This Subdomain Active', verbose_name='Is Active')),
                ('default_access', models.BooleanField(default=False, help_text='Default Access For This Subdomain If No Other Access Is Set', verbose_name='Default Access')),
                ('excluded_by_groups', models.BooleanField(default=False, help_text='Deny By Groups is Active For This Subdomain or Not', verbose_name='Excluded By Groups')),
                ('excluded_by_users', models.BooleanField(default=False, help_text='Deny By Users is Active For This Subdomain or Not', verbose_name='Excluded By Users')),
                ('excluded_by_role', models.BooleanField(default=False, help_text='Deny By Role is Active For This Subdomain or Not', verbose_name='Excluded By Role')),
                ('excluded_by_ip_range', models.BooleanField(default=False, help_text='Deny By IP Range is Active For This Subdomain or Not', verbose_name='Excluded By IP Range')),
                ('excluded_role', models.TextField(blank=True, default='', help_text='Roles Denied Access to this Subdomain If More Than One Role Separate Them With Comma', max_length=255, null=True, verbose_name='Roles Excluded')),
                ('excluded_ip_range_from', models.GenericIPAddressField(blank=True, default='', help_text='IP Range Denied From', null=True, verbose_name='IP Range Denied From')),
                ('excluded_ip_range_to', models.GenericIPAddressField(blank=True, default='', help_text='IP Range Denied To', null=True, verbose_name='IP Range Denied To')),
                ('included_by_groups', models.BooleanField(default=False, help_text='Allow By Groups is Active For This Subdomain or Not', verbose_name='Included By Groups')),
                ('included_by_users', models.BooleanField(default=False, help_text='Allow By Users is Active For This Subdomain or Not', verbose_name='Included By Users')),
                ('included_by_role', models.BooleanField(default=False, help_text='Allow By Role is Active For This Subdomain or Not', verbose_name='Included By Role')),
                ('included_by_ip_range', models.BooleanField(default=False, help_text='Allow By IP Range is Active For This Subdomain or Not', verbose_name='Included By IP Range')),
                ('included_role', models.TextField(blank=True, default='', help_text='Roles Allowed Access to this Subdomain If More Than One Role Separate Them With Comma', max_length=255, null=True, verbose_name='Roles Included')),
                ('included_ip_range_from', models.GenericIPAddressField(blank=True, default='', help_text='IP Range Allowed From', null=True, verbose_name='IP Range Allowed From')),
                ('included_ip_range_to', models.GenericIPAddressField(blank=True, default='', help_text='IP Range Allowed To', null=True, verbose_name='IP Range Allowed To')),
                ('excluded_groups', models.ManyToManyField(help_text='Groups Denied Access to this Subdomain', related_name='excluded_groups_subdomains', to='auth.group')),
                ('excluded_users', models.ManyToManyField(blank=True, help_text='Users Denied Access to this Subdomain', related_name='excluded_users_subdomains', to=settings.AUTH_USER_MODEL)),
                ('included_groups', models.ManyToManyField(blank=True, help_text='Groups Allowed Access to this Subdomain', related_name='included_groups_subdomains', to='auth.group')),
                ('included_users', models.ManyToManyField(blank=True, help_text='Users Allowed Access to this Subdomain', related_name='included_users_subdomains', to=settings.AUTH_USER_MODEL)),
            ],
            options={
                'verbose_name': 'Subdomain',
                'verbose_name_plural': 'Subdomains',
                'unique_together': {('base_domain', 'subdomain')},
            },
        ),
    ]
